{
test program for unzip, using a simple Pascal object
}
PROGRAM test2;
{$I unzip.Inc}

{$ifdef windows}
USES
{$ifndef __TMT__}
wintypes,
winprocs,
{$else}
windows,
messages,
{$endif}
{$ifdef Delphi}sysutils, {$else}windos, strings, {$endif Delphi}
unzip,
zipinter,
ziptypes,
wincrt;
{$else}
USES
dos,
crt,
strings,
unzip,
ziptypes;
{$endif}

TYPE
UnZipObject = OBJECT
   CONSTRUCTOR Init ( CONST ZipFile, Directory, FileSpecs : String;Report : UnzipReportProc );
   DESTRUCTOR  Done;virtual;
   FUNCTION    Run : integer;virtual;
   FUNCTION    View : integer;virtual;
   PRIVATE
      NoRecurse:Boolean;
      aName,
      aDir,
      aSpec : String;
      ZipReport : UnzipReportProc;
END;

{/////////////////////////////////////////////////////}
PROCEDURE Report ( Retcode : longint;R : pReportRec );
{$ifdef Bits32}STDCALL;{$else}
{$ifdef Windows}EXPORT;{$endif}{$endif}
BEGIN
  WITH r^ DO
  CASE Status of
  file_completed :
   Writeln
   (
   UnzipMethods [ packmethod ] : 9,
   '  ', Size : 9,
   '  ', CompressSize : 9,
   '  ', Ratio : 5, '%',
   '  ', strpas(filename)
   );
   unzip_completed :
   Writeln
   (
   'Archived' : 9,
   '  ', Size : 9,
   '  ', CompressSize : 9,
   '  ', Ratio : 5, '%',
   '  ', strpas(filename)
   );
 END {case}
END; {Report}
{/////////////////////////////////////////////////////}
PROCEDURE Report2 ( Retcode : longint;R : pReportRec );
{$ifdef Bits32}STDCALL;{$else}
{$ifdef Windows}EXPORT;{$endif}{$endif}
BEGIN
   WITH r^ DO
   Writeln
   (
   UnzipMethods [ packmethod ] : 9,
   '  ', Size : 9,
   '  ', CompressSize : 9,
   '  ', Ratio : 5, '%',
   '  ', strpas(filename)
   );
END; {Report2}
{/////////////////////////////////////////////////////}
CONSTRUCTOR UnZipObject.Init;
BEGIN
  ZipReport := Report;
  NoRecurse := Upper ( paramstr ( ParamCount ) ) = '/D-'; {/D- = don't recurse}
  If (NoRecurse) and (ParamCount < 4)
  then aSpec := '*.*' else aSpec := FileSpecs;
  aName := ZipFile;
  IF pos ( '.', aName ) = 0 THEN aName := aName + '.ZIP';
  aName := aName + #0;
  aSpec := aSpec + #0;
  adir  := Directory + #0;
END;

DESTRUCTOR  UnZipObject.Done;
BEGIN
  SetNoRecurseDirs ( FALSE );
END;

FUNCTION    UnZipObject.Run : integer;
BEGIN
  SetNoRecurseDirs ( NoRecurse );
  Run := FileUnzip ( @aName [ 1 ], @aDir [ 1 ], @aSpec [ 1 ], ZipReport, NIL );
END;

FUNCTION    UnZipObject.View : integer;
BEGIN
{$IFNDEF __TMT__}
  View := ViewZip ( @aName [ 1 ], @aSpec [ 1 ], Report2 );
{$ELSE}
  View := ViewZip ( @aName [ 1 ], @aSpec [ 1 ], @Report2 );
{$ENDIF}
END;

VAR
Zip : UnZipObject;
i : integer;
p : pchar;
BEGIN
  IF ( paramcount < 2 )
  THEN BEGIN
    getmem ( p, 512 );
    strcopy ( p, 'Syntax=TEST2 <filename.ZIP> <[target dir] or [/v]> [specs] [/D-]'#13#10#13#10 );
    Strcat ( p, 'Examples: '#13#10 );
    Strcat ( p, '    TEST2 TEST.ZIP C:\TEMP'#13#10 );
    Strcat ( p, '    TEST2 TEST.ZIP C:\TEMP *.PAS'#13#10 );
    Strcat ( p, '    TEST2 TEST.ZIP C:\TEMP ZIP*.*'#13#10 );
    Strcat ( p, '    TEST2 TEST.ZIP C:\TEMP /D-'#13#10 );
    Strcat ( p, '    TEST2 TEST.ZIP /V'#13#10 );
    Strcat ( p, '    TEST2 TEST.ZIP /V *.EXE'#13#10 );

  {$ifdef Windows}
     Messagebox ( 0, p, 'Chief''s UNZIP', 0 );
  {$else Windows}
     Writeln ( p );
  {$endif Windows}
     freemem ( p, 512 );
     halt;
  END;

  {$ifdef Windows}
{   WITH ScreenSize DO BEGIN
        x := 75;
        y := 500;
   END;
   WITH WindowOrg DO BEGIN
        x := 1;
        y := 1
   END;}
  {$endif}

  WITH Zip DO BEGIN
      {$IFNDEF __TMT__}
      Init ( ParamStr ( 1 ), ParamStr ( 2 ), ParamStr ( 3 ), Report );
      {$ELSE}
      Init ( ParamStr ( 1 ), ParamStr ( 2 ), ParamStr ( 3 ), @Report );
      {$ENDIF}
      IF ( upper ( paramstr ( 2 ) ) = '/V' ) OR ( upper ( paramstr ( 2 ) ) = '-V' )
      THEN i := View
      ELSE i := Run;
      Done;
  END;
END.
